module boolean (
   // Outputs
   bool_out_e, 
   // Inputs
   ra_data_e, rb_data_e, alu_op_e
   ) ;
   input [11:0] ra_data_e;
   input [11:0] rb_data_e;
   input [3:0]  alu_op_e;

   output [11:0] bool_out_e;

   wire [11:0]   temp0;
   wire [11:0]   temp1;

   // Note that these are 2-1 muxes

   assign temp0[11:0] = (~ra_data_e[11:0] & {12{alu_op_e[3]}}) | (ra_data_e[11:0] & {12{alu_op_e[2]}});   
   assign temp1[11:0] = (~ra_data_e[11:0] & {12{alu_op_e[1]}}) | (ra_data_e[11:0] & {12{alu_op_e[0]}});

   assign bool_out_e[11:0] = (~rb_data_e[11:0] & temp0[11:0]) | (rb_data_e[11:0] & temp1[11:0]);
   
endmodule // boolean
